/* $Id: support_timer.js,v 1.1 2009/06/18 03:36:15 jeremy Exp $ */

var time;
var seconds = 0;
var minutes = 0;
var hours = 0;
var enabled = 1;
var delayed = 0;

/**
 * Allow user to start or stop the timer.
 */
function pause_timer() {
  if (enabled) {
    enabled = 0;
    window.setTimeout(function() {
      delay();
    }, 1000);
  }
  else {
    if (delayed) {
      enabled = 1;
      delayed = 0;
      timer();
    }
  }
}

/**
 * Prevent multiple timers from starting at once.
 */
function delay() {
  delayed++;
}

/**
 * Reset all counters, starting the timer over at 00:00:00.
 */
function reset_timer() {
  seconds = 0;
  minutes = 0;
  hours = 0;
  display_time();
}

/**
 * Update the edit-elapsed textfield with the current elapsed time.
 */
function display_time() {
  if (hours < 10) {
    time = '0'+hours;
  }
  else {
    time = hours;
  }
  if (minutes < 10) {
    time += ':0'+minutes;
  }
  else {
    time += ':'+minutes;
  }
  if (seconds < 10) {
    time += ':0'+seconds;
  }
  else {
    time += ':'+seconds;
  }
  $(document).ready(function() {
    $("#edit-elapsed").val(time);
  });
}

/**
 * Count seconds.
 */
function timer() {
  if (!enabled) {
    return false;
  }
  display_time();
  seconds += 1;
  if (seconds >= 60) {
    seconds = 0;
    minutes++;
  }
  if (minutes >= 60) {
    minutes = 0;
    hours++;
  }
  window.setTimeout(function() {
    timer();
  }, 1000);
}

/**
 * Start the timer when the script is loaded.
 */
timer();
